from tw.api import Widget, JSLink, CSSLink, JSSource
from tw.extjs import all, all_css, gray_theme

from paraxip.gateway_gui_widgets import debug, base, extjsOverrides


class TabPstnJS(JSSource):
    _resources = []
    
    alarms_script = \
                    JSLink(link="/static/javascript/widgets_src/status/alarms.js")
    channels_script = \
                    JSLink(link="/static/javascript/widgets_src/status/channels.js")
    controls_script = \
                    JSLink(link="/static/javascript/widgets_src/status/controls.js")
    system_status_script = \
                    JSLink(link="/static/javascript/widgets_src/status/systemStatus.js")
    routing_rules_script = \
                    JSLink(link="/static/javascript/widgets_src/routingRules.js")
    filebrowser_script = \
                    JSLink(link="/static/javascript/widgets_src/fileBrowser.js")

    javascript=[all, 
                base.oam_common_lib_script,
                base.BrowseButton,
                base.FileUploader,
                base.UploadPanel,
                base.FileTreeMenu,
                base.FileTreePanel,
                base.ThemeCombo,
                base.IconCombo,
                base.LangSelectCombo,
                base.css_override, 
                base.filetree_icons, 
                base.filetree_filetree, 
                base.filetree_filetype, 
                base.filetree_famflag, 
                base.filetree_IconCombo, 
                base.filetree_empty, 
                debug.paraxip_console_script,
                extjsOverrides.overrides_script, 
                alarms_script,
                channels_script,
                controls_script,
                system_status_script,
                routing_rules_script,
                filebrowser_script]
    
  
    params = source_vars = ["tabs", 
                            "items", 
                            "width", 
                            "height", 
                            "renderTo", 
                            "autoScroll", 
                            "plain",
                            "activeTab", 
                            "frame", 
                            "tabList",
                            "src_file",
                            "offerVirtualBoards",
                            "isGatewayInCLI"]

    tabs = {'Tab Title 1': ['Tab content 1','Tab id 1','Tab 1'],'Tab Title 2': ['Tab content 2','Tab id 2','Tab 2']}
    items = [{'html': k.replace(" ","").lower(), 'title': k, 'id':v[1], 'tabTip': v[2],'renderTo':k.replace(" ","").lower()} for k, v in tabs.items()]
    tabList = [(k.replace(" ","").lower(),v[0],v[1],v[2]) for k, v in tabs.items()]

    frame = 'false'
    activeTab=0
    width = "300"
    height = "600"
    autoScroll = 'true'
    plain = 'true'

    src=""

    template_engine=" "

    def __init__(self, *args, **kw):
        super(TabPstnJS, self).__init__(*args, **kw)

    def update_params(self, d):
        for param in self.source_vars:
            value = getattr(self, param)
            if isinstance(value, bool):
                d[param] = str(value).lower()
        super(TabPstnJS, self).update_params(d)

    def post_init(self, *args, **kw):
        pass

tabpstn_js = TabPstnJS()

class TabPSTN(Widget):
    tabpstn_js_obj = TabPstnJS
    
    params = js_params =   ["tabs", 
                            "items", 
                            "width", 
                            "height", 
                            "renderTo", 
                            "activeTab", 
                            "frame", 
                            "autoScroll", 
                            "plain", 
                            "tabList",
                            "src_file",
                            "offerVirtualBoards",
                            "isGatewayInCLI"]

    engine_name = "kid"
    template = """
    <div  id="$renderTo" xmlns="http://www.w3.org/1999/xhtml" xmlns:py="http://purl.org/kid/ns#">
        <div py:for="tab in tabList" id="${tab[0]}">
        </div>
    </div>

    """

    
    def __init__(self, *args, **kw):
        super(TabPSTN, self).__init__(*args, **kw)

    def load_src(self, src_name):
        """
        src_name == dotted.path.to.template (without .ext)
        
        """
        src_file = open(src_name)
        src_obj = src_file.read()
        src_file.close()
        #src_obj =""
        return src_obj

    def __new__(cls, *args, **kw):
        cls = Widget.__new__(cls, *args, **kw)
        d = {}

        #copy in parameters from this class to the javascript class (keeps all of the params in one place)
        for param in cls.js_params:
            value = getattr(cls, param)
            if value is not None:
                d[param] = getattr(cls, param)
                if param == "src_file":
                    cls.tabpstn_js_obj.src = cls.load_src(value)

        tabpstn_js = cls.tabpstn_js_obj(**d)
        cls.javascript = [tabpstn_js,]
        return cls
 
    

